-----------------------------------------------------------
-- (a)	Eliminare larticolo con di codice 101
DELETE
FROM	Articolo
WHERE 	CodA = 101;

-----------------------------------------------------------
-- (b)	Eliminare la rivista di nome 'In Sella'
DELETE
FROM	Rivista
WHERE	NomeR = 'In Sella';
-- Nota: l'eliminazione causa errore se esistono
--       articoli della rivista 'In Sella'

-----------------------------------------------------------
-- (c)	Eliminare tutti gli articoli della rivista
--      di nome 'In Sella' 
DELETE
FROM	Articolo
WHERE	CodR = (
	SELECT	CodR
	FROM	Rivista
	WHERE	NomeR = 'In Sella'
);

-----------------------------------------------------------
-- (d)	Eliminare la rivista di nome 'In Sella'
DELETE
FROM	Rivista
WHERE	NomeR = 'In Sella';
-- Nota: l'eliminazione  ora eseguita in ogni caso
	
-----------------------------------------------------------
-- (e)	Eliminare tutti gli articoli di argomento
--      'Auto' o di 'Vela'
DELETE
FROM	Articolo
WHERE 	Argomento = 'Auto'
		OR Argomento = 'Vela';
		
-----------------------------------------------------------
-- Per chi svolge l'esercitazione con il PC:
-- ripristinare il contenuto del DB con l'apposito script	

-----------------------------------------------------------
-- (f)	In tutti gli articoli di argomento 'Auto',
--      modificare l'argomento in 'Automobile'
UPDATE	Articolo
SET		Argomento = 'Automobile'
WHERE 	Argomento = 'Auto';

-----------------------------------------------------------
-- (g)	In tutti gli articoli di argomento 'Motociclismo'
--      pubblicati nella rivista 'In Sella',
--      modificare l'argomento in 'Moto'
UPDATE	Articolo
SET		Argomento = 'Moto'
WHERE 	Argomento = 'Motociclismo'
		AND CodR = (
			SELECT	CodR
			FROM	Rivista
			WHERE	NomeR = 'In Sella'
		);

-----------------------------------------------------------
-- (h) Inserire una nuova rivista con i seguenti dati:
--     CodR   : 'R11'
--     NomeR  : 'Nuove Moto'
--     Editore: 'GEDI'
INSERT	INTO Rivista
VALUES	('R11', 'Nuove Moto', 'GEDI');

-----------------------------------------------------------
-- (i) Inserire nella rivista 'Nuove Moto' una copia
--     di tutti gli articoli della rivista 'In Sella'
--     (con CodA qualsiasi purch univoco!)
INSERT	INTO Articolo
SELECT	CodA + 100, Titolo, Argomento, (
			SELECT	CodR
			FROM	Rivista
			WHERE	NomeR = 'Nuove Moto'
		)
FROM	Articolo
WHERE 	CodR = (
			SELECT	CodR
			FROM	Rivista
			WHERE	NomeR = 'In Sella'
		);

-----------------------------------------------------------
-- (j) Modificare le clausole di integrit referenziale
--     in Articolo in modo che la cancellazione di una
--     rivista comporti la cancellazione in cascata
--     di tutti i suoi articoli (2 passi)

-- Passo 1 - Versione Oracle
ALTER TABLE Articolo DROP CONSTRAINT fk_CodR;
-- Passo 1 - Versione MySQL
ALTER TABLE Articolo DROP FOREIGN KEY fk_CodR;

-- Passo 2 - Versione Oracle e MySQL
ALTER TABLE Articolo ADD CONSTRAINT fk_CodF
	FOREIGN KEY (CodR)
	REFERENCES Rivista(CodR)
	ON DELETE CASCADE;

-----------------------------------------------------------
-- (k) Eliminare la rivista 'Nuove Moto'
DELETE
FROM	Rivista
WHERE	NomeR = 'Nuove Moto';
-- Nota: l'eliminazione della rivista comporta anche
--       l'eliminazione di tutti i suoi articoli

-----------------------------------------------------------
-- (l) Modificare le clausole di integrit referenziale
--     in Articolo in modo che la cancellazione di una
--     rivista comporti l'assegnazione di NULL
--     al codice della rivista (2 passi)

-- Passo 1 - Versione Oracle
ALTER TABLE Articolo DROP CONSTRAINT fk_CodF;
-- Passo 1 - Versione MySQL
ALTER TABLE Articolo DROP FOREIGN KEY fk_CodF;

-- Passo 2 - Versione Oracle e MySQL
ALTER TABLE Articolo ADD CONSTRAINT fk_CodF
	FOREIGN KEY (CodR)
	REFERENCES Rivista(CodR)
	ON DELETE SET NULL;
	
-----------------------------------------------------------
-- (m) Eliminare la rivista di nome 'Due Ruote'
DELETE
FROM	Rivista
WHERE	NomeR = 'Due Ruote';
-- Nota: l'eliminazione della rivista comporta che i
--       suoi articoli non vengano eliminati ma il valore
--       di CodR diventi NULL